<template>
  <div>
    <BarChart :chart-data="datacollection" :options="options" :height="300" />
  </div>
</template>

<script>
import BarChart from '@/components/chart/bar.js'
import covertDate from '@/mixins/formateDate'
import axios from 'axios'
export default {
  mixins: [covertDate],
  components: {
    BarChart,
  },
  props: {
    setDataDate: Number,
  },
  data() {
    return {
      datacollection: null,
      options: null,
      setTotalData: [],
      dateLabels: [
        'ม.ค.',
        'ก.พ.',
        'มี.ค.',
        'เม.ย.',
        'พ.ค.',
        'มิ.ย.',
        'ก.ค.',
        'ส.ค.',
        'ก.ย.',
        'ต.ค.',
        'พ.ย.',
        'ธ.ค.',
      ],
    }
  },
  mounted() {
    this.fillData()
    this.getDataAxios()
  },
  watch: {
    getdashboardTime(newVal, oldVal) {
      this.getDataAxios(
        this.$nuxt.$store.state.template.dashboardTime,
        this.$nuxt.$store.state.expensestable.ExpensesTable,
        this.$nuxt.$store.state.expensestype.ExpensesType,
        this.amountWeek
      )
    },
  },
  methods: {
    fillData() {
      this.datacollection = {
        labels: this.dateLabels,
        datasets: this.setTotalData,
      }
      this.options = {
        labels: true,
        responsive: true,
        maintainAspectRatio: false,
        height: '250',
        scales: {
          yAxes: [
            {
              ticks: {
                beginAtZero: true,
                min: 0,
                stepSize: 500,
                display: true,
              },
              gridLines: {
                display: true,
              },
            },
          ],
          xAxes: [
            {
              ticks: {
                display: true,
                beginAtZero: true,
              },
              gridLines: {
                display: true,
              },
            },
          ],
        },
        plugins: {
          stacked100: { enable: true },

          datalabels: {
            formatter: function (value) {
              if (value == 0) {
                return ''
              }
              return parseInt(value).toLocaleString('th-TH', {
                style: 'currency',
                currency: 'THB',
              })
            },
            color: 'blue',
            labels: {
              title: { color: 'blue', font: { weight: 'bold' } },
              value: { color: 'green' },
            },
          },
        },
        responsive: true,
        maintainAspectRatio: false,
      }
    },
    async getDataAxios(
      timeVal = new Date(),
      expensestable = 0,
      expensestype = 0
    ) {
      if (expensestable) {
        const checkTime = timeVal

        const date = new Date(checkTime)
        const firstDay = new Date(date.getFullYear(), 0, 1)
        const lastDay = new Date(date.getFullYear(), 11, 31)

        const dayStart = firstDay.getTime()
        const dayEnd = lastDay.getTime()

        const dataRes = this.totalTypeMulti(expensestable, dayStart, dayEnd)

        const countTypeName = expensestype.map((x) => x.name).length

        const getArray = this.setArray(dataRes, countTypeName, 12)
        const getObject = this.setObject(getArray, expensestype, countTypeName)

        this.setTotalData = getObject
        this.fillData()
      }
    },
    setArray(objData, coutName, countMonth) {
      const arrayDeserts = new Array(coutName)
      for (let i = 0; i < arrayDeserts.length; i++) {
        arrayDeserts[i] = new Array(2)
      }

      for (let i = 0; i < coutName; i++) {
        for (let j = 0; j < countMonth; j++) {
          objData.forEach((res) => {
            let d = new Date(res.date)
            if (res.id - 1 == i) {
              if (d.getMonth() == j) {
                if (arrayDeserts[i][j] > 0) {
                  arrayDeserts[i][j] = arrayDeserts[i][j] + res.price
                } else {
                  arrayDeserts[i][j] = res.price
                }
              }
            }
          })
          if (arrayDeserts[i][j] == null) {
            arrayDeserts[i][j] = ''
          }
        }
      }
      return arrayDeserts
    },
    setObject(arrayData, typeName, countMonth) {
      let datasetts = []
      for (let i = 0; i < countMonth; i++) {
        const dataset = {
          label: typeName[i].name,
          backgroundColor: this.bgColor(i),
          borderColor: ['#FFF'],
          data: arrayData[i],
        }
        datasetts = [...datasetts, dataset]
      }
      return datasetts
    },
  },
}
</script>
